import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

public class ScrollableDotPlot extends JPanel implements Scrollable{

  boolean bFirstTime = true;		
  private Dimension size;

  double iscale = 128;
  
  String ContigLabel = "";  
  DotPlotEngine mDPE; 

  //JLabel mLabel;
  //String mLabelText;

  private int maxUnitIncrement = 1;
  
  public void setIScale(double val){
    iscale = val;
    System.out.println("iscale="+iscale);
    repaint();
  }

  protected void paintComponent(Graphics g){
    super.paintComponent(g);	
    Graphics2D g2d = (Graphics2D) g;			 
    FontMetrics fontMetrics = g2d.getFontMetrics();
    
    Rectangle clip = g.getClipBounds();
    g.setColor(Color.blue);
    
    int width = getSize().width -1;
    int height = getSize().height-1;      
    // for(int q = 0; q< mDPE->mPixels.size();q++){
    int q = 0;
    
    // For performance, only repaint the clip region....
    int bugCount = 0;
    for(int x = clip.x;x < clip.x+clip.width;x++){
      for(int y = clip.y; y < clip.y+clip.height;y++){		  
	int intensity = mDPE.GetIntensity2(q,x,y);

	// Don't plot the white bits... 
	if (intensity > 0){
	  int diff = (int) (intensity * iscale);
	  int val = (255-diff);
	  if (val < 0) val = 0;
	  g.setColor(new Color(val,255,val));
	  g.fillRect(x,y,2,2);
	}
      }
    }

    // Paint reverse hits...
    for(int x = clip.x;x < clip.x+clip.width;x++){
      for(int y = clip.y; y < clip.y+clip.height;y++){		  
	int intensity = mDPE.GetRevIntensity2(q,x,y);

	// Don't plot the white bits... 
	if (intensity > 0){
	  int diff = (int) (intensity * iscale);
	  int val = (255-diff);
	  if (val < 0) val = 0;
	  g.setColor(new Color(val,val,255));
	  g.fillRect(x,y,2,2);
	}
      }
    }

  }    

  public ScrollableDotPlot(DotPlotEngine DPE){
    mDPE = DPE;
    maxUnitIncrement = 32;
    setBackground(Color.white);
    setOpaque(true);
  }

  public Dimension getPreferredScrollableViewportSize() {
    return getPreferredSize();
  }

  public int getScrollableUnitIncrement(Rectangle visibleRect,
					int orientation,
					int direction) {

    return(25);

    // I believe the purpose of this was to make the display 
    // move in tic mark inrements.  
    /*
    //Get the current position.
    int currentPosition = 0;
    if (orientation == SwingConstants.HORIZONTAL)
      currentPosition = visibleRect.x;
    else
      currentPosition = visibleRect.y;

    //Return the number of pixels between currentPosition
    //and the nearest tick mark in the indicated direction.
    if (direction < 0) {
      int newPosition = currentPosition - 
	(currentPosition / maxUnitIncrement) *
	maxUnitIncrement;
      return (newPosition == 0) ? maxUnitIncrement : newPosition;
    } else {
      return ((currentPosition / maxUnitIncrement) + 1) *
	maxUnitIncrement - currentPosition;
    }
    */
  }

  public int getScrollableBlockIncrement(Rectangle visibleRect,
					 int orientation,
					 int direction) {

    return(50);

    /*
    if (orientation == SwingConstants.HORIZONTAL)
      return visibleRect.width - maxUnitIncrement;
    else
      return visibleRect.height - maxUnitIncrement;
    */
  }

  public boolean getScrollableTracksViewportWidth() {
    return false;
  }

  public boolean getScrollableTracksViewportHeight() {
    return false;
  }

  public void setMaxUnitIncrement(int pixels) {
    maxUnitIncrement = pixels;
  }
}
